/*
 * Created on May 31, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.data.query;


/**
 * @author staworko
 *
 */
public abstract class Axis
{
    public static final Axis SELF      = new Axis() {
        public boolean isRefl() {
            return true;
        }
    };
    
    public static final Axis CHILD     = new Axis() {};
    public static final Axis CHILD_T   = new TransAxis(CHILD);
    public static final Axis CHILD_TR  = new TransReflAxis(CHILD);
    public static final Axis LEFT      = new Axis() {};
    public static final Axis LEFT_T    = new TransAxis(LEFT);
    public static final Axis LEFT_TR   = new TransReflAxis(LEFT);
//    public static final Axis PARENT    = new Axis() {};
//    public static final Axis PARENT_T  = new TransAxis(PARENT);
//    public static final Axis PARENT_TR = new TransReflAxis(PARENT);
//    public static final Axis RIGHT     = new Axis() {};
//    public static final Axis RIGHT_T   = new TransAxis(RIGHT);
//    public static final Axis RIGHT_TR  = new TransReflAxis(RIGHT);
    
    
    public static class TransAxis extends Axis {        
        private Axis baseAxis;

        public TransAxis(Axis baseAxis)
        {
            this.baseAxis = baseAxis;
        }
        
        public Axis getBaseAxis()
        {
            return baseAxis;
        }
        
        public boolean isTrans()
        {
            return true;
        }
        
    }

    public static class TransReflAxis extends TransAxis {

        /**
         * @param baseAxis
         */
        public TransReflAxis(Axis baseAxis)
        {
            super(baseAxis);            
        }
        
        public boolean isRefl()
        {
            return true;
        }
    }
    
    public Axis getBaseAxis() 
    {
        return this;
    }
    
    public boolean isTrans() {
        return false;
    }
    
    public boolean isRefl()
    {
        return false;
    }
    
    public boolean isTransRefl()
    {
        return isTrans() && isRefl();
    }    
}
