/*
 * Created on May 31, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.data.query;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import edu.buffalo.nsf.xmlcqa.tree.TreeNode;


/**
 * @author staworko
 *
 */
public abstract class NodeTest
{
    public static final NodeTest STAR = new NodeTest() {
        public boolean test(TreeNode node)
        {
            return true;
        }};
    public static final NodeTest EMPTY = STAR;
    public static final NodeTest NODE = new NodeTest() {
        public boolean test(TreeNode node)
        {
            return node.isNode();
        }};
    public static final NodeTest TEXT = new NodeTest() {
        public boolean test(TreeNode node)
        {
            return node.isText();
        }};
    /**
     * @param root
     * @return
     */
    public abstract boolean test(TreeNode node);
    /**
     * @param nodes
     * @return
     */
    public Collection filter(Collection nodes)
    {
        Collection result = new HashSet(nodes.size());
        Iterator iter = nodes.iterator();
        
        while (iter.hasNext()) {
            Object a = iter.next();
            
            try {
            TreeNode node = (TreeNode) a;
            if (test(node)) {
                result.add(node);
            }
            } catch (ClassCastException exc) {
                System.out.println("Class: " + a.getClass().toString());
                throw exc;
            }
        }
        
        return result;
    }
    


}
