/*
 * Created on Feb 25, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.data.stream;

/**
 * Class representing device reading tokens. The {@link #close()} method 
 * has to be used to inform the device that no further tokens will be 
 * consumed. It is the user responsibility to assure that the suplied stream 
 * of tokens is balanced.  
 * 
 * @author staworko
 * 
 */
public interface TokenSink
{

    /**
     * Method closing the sink. 
     * After call to this method no other methods should be used.  
     */
    public void close();

    /**
     * Method consuming a token.
     */
    public  void consume(Token t);

}