/*
 * Created on Jun 5, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.graph;

import edu.buffalo.nsf.xmlcqa.tree.OperationManager;


/**
 * @author staworko
 *
 */
public class FloodCQA extends CQA
{
 
    public FloodCQA(OperationManager mgr)
    {
        super(mgr);
    }
    public FloodCQA(OperationManager mgr, int threshold)
    {
        super(mgr, threshold);
    }
    
    protected Vertex[] semiForce(Vertex[] next, Vertex[] mem)
    {
        for (int i = 0; i < next.length; i++) {
            next[i].register();
        }
        
        for (int i = 0; i < mem.length; i++) {
            if (mem[i].isRegistered()) {
                mgr.evaluate(mem[i]);
            }
        }
        
        for (int i = 0; i < mem.length; i++) {
            if (mem[i].isRegistered()) {
                floodGentleEvaluation(mem[i],mgr);
            }
        }
        
        mem = snapshot(next,mem);
        
        for (int i = 0; i < next.length; i++) {
            next[i].unregister();
        }
        
        return next;
    }
    
    private void floodGentleEvaluation(Vertex v, OperationManager mgr)
    {
        if (!v.willCauseCloning()) {
            mgr.evaluate(v);
            Edge e = v.out;
            while (e != null) {
                if (e.to.isRegistered()) {
                    floodGentleEvaluation(e.to,mgr);
                }
                e = e.nextOut;
            }
        }
    }
}