package edu.buffalo.nsf.xmlcqa.test;

import edu.buffalo.nsf.xmlcqa.data.dtd.Clousure;
import edu.buffalo.nsf.xmlcqa.data.dtd.RegExpr;
import edu.buffalo.nsf.xmlcqa.data.dtd.Tag;
import edu.buffalo.nsf.xmlcqa.data.dtd.Union;
import edu.buffalo.nsf.xmlcqa.data.stream.FileTokenSink;
import edu.buffalo.nsf.xmlcqa.data.stream.Token;

public class DeltaTest {

	public DeltaTest() {
		super();
		// TODO Auto-generated constructor stub
	}

	protected static void writeElement(FileTokenSink f, int tagID, String text) {

		f.consume(Token.createTag(tagID));
		f.consume(Token.createText(text));
		f.consume(Token.CLOSING_TOKEN);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub

		boolean[][][] delta;
		boolean[][] epsdelta;
		boolean[] finalstates;

		Tag a = Tag.get("a");
		Tag b = Tag.get("b");

		Clousure c = new Clousure(a);

		// RegExpr r = new Union(new Clousure(new Concat(a, b)),
		// RegExpr.EPSILON);
		RegExpr r = new Union(new Clousure(a), new Clousure(b));

		FileTokenSink f = new FileTokenSink("c:\\test.xml");
		f.consume(Token.createTag("toor"));

		if (r instanceof Tag) {
			writeElement(f, r.hashCode(), "Tag");
		}

		System.out.println(r);
		delta = r.getDelta();
		epsdelta = r.getEpsilonDelta();
		finalstates = r.getFinalStates();

		// print epsilon delta table
		for (int i = 0; i < epsdelta.length; i++) {
			for (int j = 0; j < epsdelta[i].length; j++) {
				System.out.print(epsdelta[i][j] + "  ");
			}
			System.out.println("");
		}

		// print the final states
		for (int i = 0; i < finalstates.length; i++) {
			System.out.println(finalstates[i]);
		}

		// print the transition table
		for (int l = 0; l < Tag.getCount(); l++) {
			for (int i = 0; i < delta.length; i++) {
				for (int j = 0; j < delta[i].length; j++) {
					for (int k = 0; k < delta[i][j].length; k++) {
						if (i == l & delta[i][j][k]) {
							System.out.println(Tag.getTag(i) + ": " + j + " --> "
									+ k + " ");
						}
					}
				}
				
			}
		}

		f.consume(Token.CLOSING_TOKEN);
		f.close();
	}

}
