/*
 * Created on Oct 13, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.test;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;
import javax.xml.stream.XMLStreamException;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.dtd.Tag;
import edu.buffalo.nsf.xmlcqa.data.stream.generator.DocumentGenerator;
import edu.buffalo.nsf.xmlcqa.data.stream.generator.RandomDocumentGenerator;
import edu.buffalo.nsf.xmlcqa.util.Util;


/**
 * @author staworko
 *
 */
public class RandDocGenTest
{
    protected static DecimalFormat format = new DecimalFormat("00.000");
    
    public static String format(double val) {
        return format.format(val);
    }
    
    public static void main(String[] args) throws IOException, XMLStreamException
    {
        DTD dtd = DTDs.dtd[0].init();
        String file = "d:\\work\\xml\\test\\rand.xml";
        
        DocumentGenerator gen = new RandomDocumentGenerator(dtd,Tag.get("a"));
        
        long size[] = {1000,10000,100000,1000000,10000000,100000000,1000000000};
        
        Map param = new HashMap();
                       
        for (int i = 0; i < size.length; i++) {            
            param.put(DocumentGenerator.SIZE_PARAM,new Long(size[i]));        
            param.put(DocumentGenerator.RATIO_PARAM,new Double(1000.0 * size[i]));        
            gen.generate(file,param);
            System.out.print(" " + size[i] + " | ");
            System.out.print(" " + format((new File(file)).length() /(1024.0*1024.0)) + " | ");
            System.out.print(Util.measureDepth(file) + "\n");
        }
        
    }
}
