/*
 * Created on Jun 10, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.test;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import edu.buffalo.nsf.xmlcqa.data.dtd.Clousure;
import edu.buffalo.nsf.xmlcqa.data.dtd.Concat;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.dtd.RegExpr;
import edu.buffalo.nsf.xmlcqa.data.dtd.Tag;
import edu.buffalo.nsf.xmlcqa.data.query.Axis;
import edu.buffalo.nsf.xmlcqa.data.query.FilterExpr;
import edu.buffalo.nsf.xmlcqa.data.query.NodeTest;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.query.Query.Step;
import edu.buffalo.nsf.xmlcqa.data.stream.FileTokenSink;
import edu.buffalo.nsf.xmlcqa.data.stream.Token;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenSink;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;


/**
 * @author staworko
 *
 */
public class Test
{
    public static Tag a = Tag.get("a");
    public static Tag b = Tag.get("b");
    public static Tag c = Tag.get("c");
    public static DTD dtd;
    static {
        Map defs = new HashMap(3);        
        defs.put(a, RegExpr.EPSILON);
        defs.put(b, RegExpr.EPSILON);
        defs.put(c, new Clousure(new Concat(a, b)));
        dtd = new DTD(defs).init();
                
    }
    public static Token      A    = Token.createTag("a");
    public static Token      B    = Token.createTag("b");
    public static Token      C    = Token.createTag("c");
    public static Query      path = 
        new Query (new Query.Step[]{new Step(Axis.LEFT, NodeTest.NODE, FilterExpr.createTagFilter(a)),
                                    new Step(Axis.CHILD,NodeTest.STAR, FilterExpr.EMPTY),
                                    new Step(Axis.CHILD_TR, NodeTest.STAR, FilterExpr.EMPTY)
        });


    protected static DecimalFormat format = new DecimalFormat("00.000");
    
    public static String format(double val) {
        return format.format(val);
    }
    
    public static double diff(Date start, Date stop){
        return (stop.getTime() - start.getTime())/1000.0;        

    }
    
    public static double measure(double[] timing)
    {
        if(timing.length == 1) {
            return timing[0];
        }
        Arrays.sort(timing);
        double result = 0.0; 
        for (int i = 1; i < timing.length-1; i++) {
            result += timing[i];
        }
        return result/(timing.length-2);
    }
    
    public static void generateFile(String file, long size) throws IOException
    {
        TokenSink sink = new FileTokenSink(file);
        sink.consume(C);
        long i = 0; 
        while (i < size) {
            sink.consume(A);
            sink.consume(Token.CLOSING_TOKEN);
            sink.consume(B);
            sink.consume(Token.CLOSING_TOKEN);
            i++;
        }
        sink.consume(Token.CLOSING_TOKEN);
        sink.close();
    }

    public static void readFile(String file) throws IOException
    {
        Reader r = new BufferedReader(new FileReader(file));
        while (r.read() != -1) {
        }
        r.close();
    }

    public static void readStream(TokenStream ts)
    {
        while (ts.hasNext()) {
            Token t = ts.next();
        }
    }
}
