/*
 * Created on Feb 26, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.io.File;
import java.util.Date;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.FreezingCM;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;

/**
 * @author staworko
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class QueryAnswerTest extends TestUtil
{

    public static void main(String[] args) throws Exception
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] size = { 10000, 20000, 30000, 40000, 50000, 60000, 70000, 80000,
                90000, 100000, 110000, 120000, 130000, 140000, 150000, 160000,
                170000, 180000, 190000, 200000, };
        OperationManager mgr1 = new OperationManager2(CollectionManager.ARRAY_LIST_CM);
        OperationManager mgr2 = new OperationManager2(new FreezingCM(CollectionManager.ARRAY_LIST_CM));
        QueryAnswer qa1 = new QueryAnswer(mgr1);
        QueryAnswer qa2 = new QueryAnswer(mgr2);
        Query path = simpleQuery;
        TokenStream ts;
        Date start, stop;
        
        System.out.print(" NODES |  SIZE | QA1 | QA2 | QA2/QA1");

        for (int i = 0; i < size.length; i++) {
            generateCleanSimpleFile(file, size[i]);
            
            System.out.print("\n " + size[i] + " |");
            double fsize = ((new File(file)).length() / 1024) / 1024.0;
            System.out.print(format(fsize) + " |");
            double[] timing = new double[5];
            double tqa1,tqa2;

            //QA1
            for (int j = 0; j < timing.length; j++) {
                System.gc();
                ts = new StAXTokenStream(file);
                start = new Date();
                qa1.compute(ts, path);
                stop = new Date();
                timing[j] = diff(start, stop);
            }
            System.out.print(" " + format(tqa1 = measure(timing)) + " | ");

            //QA2
            for (int j = 0; j < timing.length; j++) {
                System.gc();
                ts = new StAXTokenStream(file);
                start = new Date();
                qa2.compute(ts, path);
                stop = new Date();
                timing[j] = diff(start, stop);
            }
            System.out.print(" " + format(tqa2 = measure(timing)) + " | ");
            
            System.out.print(" " + format(tqa2/tqa1) + " | ");
        }
    }
}