/*
 * Created on Jun 26, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Arrays;
import java.util.Date;
import javax.xml.stream.XMLStreamException;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.HashCutCM;
import edu.buffalo.nsf.xmlcqa.tree.LazyCloneCM;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager4;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;
import edu.buffalo.nsf.xmlcqa.util.Profiler;


/**
 * @author staworko
 *
 */
public class SmartCutTest extends TestUtil
{
    public static void main(String[] args) throws IOException, FileNotFoundException, XMLStreamException 
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] size = {
                        10000,  20000,  30000,  40000,  50000,  60000,  70000,  80000,  90000, 100000, 
                       110000, 120000, 130000, 140000, 150000, 160000, 170000, 180000, 190000, 200000,
                       210000, 220000, 230000, 240000, 250000, 260000, 270000, 280000, 290000, 300000,
                       310000, 320000, 330000, 340000, 350000, 360000, 370000, 380000, 390000, 400000,
                       410000, 420000, 430000, 440000, 450000, 460000, 470000, 480000, 490000, 500000,
                       510000, 520000, 530000, 540000, 550000, 560000, 570000, 580000, 590000, 600000, 
                       610000, 620000, 630000, 640000, 650000, 660000, 670000, 680000, 690000, 700000, 
                       710000, 720000, 730000, 740000, 750000, 760000, 770000, 780000, 790000, 800000, 
                       810000, 820000, 830000, 840000, 850000, 860000, 870000, 880000, 890000, 900000, 
                       910000, 920000, 930000, 940000, 950000, 960000, 970000, 980000, 990000, 1000000 
        };
        CollectionManager cm1 = CollectionManager.ARRAY_LIST_CM;
        CollectionManager cm2 = new LazyCloneCM(new HashCutCM(CollectionManager.ARRAY_LIST_CM));
        OperationManager  mgr1 = new OperationManager2(cm1);
        OperationManager  mgr2 = new OperationManager4(cm2);
        QueryAnswer qa = new QueryAnswer(mgr1);
        CQA cqa = new CQA(mgr2, 5);
        TokenStream ts;
        Date start, stop;
        DTD dtd = simpleDTD;
        Query path = simpleQuery;

        Profiler.deactivate();
        //System.setOut(new PrintStream(new FileOutputStream("c:\\exper-result.txt")));        
        System.out.print(" Nodes |  Size   |    QA   | STD_DEV |   CQA   |  STD_DEV | CQA/QA  |\n");
        for (int i = 0; i < size.length; i++) {
            System.out.print(" " + size[i] + " | ");
            double errors = 0.02;
            generateDirtySimpleFile(file, size[i],errors);
            double fsize = ((1.0 * new File(file).length()) / 1024.0) / 1024.0;
            System.out.print(" " + format(fsize) + " | ");
            double[] timing = new double[7];
            double tqa,tcqa;
            
            //QA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc(); 
                start = new Date();
                qa.compute(ts, path);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tqa = measure(timing))+ " | ");
            System.out.print(" " + format(std_dev(timing))+ " | ");

            //LCQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                generateDirtySimpleFile(file, size[i],errors);
                ts = new StAXTokenStream(file);
                Profiler.init();
                //OperationManager4.init();
                System.gc();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tcqa = measure(timing)) + " | " );
            System.out.print(" " + format(std_dev(timing))+ " | ");
  
            
//            System.out.print(" " + format(Profiler.getStat("Vertex.register()")) +  " | ");
            System.out.print(" " + format(tcqa/tqa) + " | ");
            System.out.print("\n");            
            
//            System.out.print("QA-CM-STAT    = " + stat1 + "\n");
//            System.out.print("CQA-CM-STAT   = " + stat2 + "\n");
//            System.out.print("LCQA-CM-STAT  = " + stat3 + "\n");
//            System.out.print("QA-MGR-STAT   = " + mgr1 + "\n");
//            System.out.print("CQA-MGR-STAT  = " + mgr2 + "\n");
//            System.out.print("LCQA-MGR-STAT = " + mgr3 + "\n");
            
            //Profiler.printStats();
//            System.out.println("AVG TICK => " + format(OperationManager4.avg_tick()) + " ");
//            System.out.println("SUM EXTRA TICKS => " + format(OperationManager4.tick_sum()) + " ");
            System.out.flush();
        }

    }
}
