/*
 * Created on Jun 12, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.util.Date;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.StatOM;

/**
 * @author staworko
 *  
 */
public class TestForDTD extends TestUtil
{

    public static void main(String[] args) throws Throwable
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] dtdsize = { 1, 5, 10, 15, 20, 25, 30, 35, 40 };
        int size = 10000;
        OperationManager mgr = new OperationManager2(CollectionManager.ARRAY_LIST_CM);
        StatOM smgr = new StatOM(mgr);
        CQA cqa = new CQA(mgr, 4);
        Query path = simpleQuery;
        
        System.out.print("  LP | STATE COUNT | AVG IN/OUT| MAX OUT | MAX IN");
        for (int i = 0; i < dtdsize.length; i++) {
            TokenStream ts;
            Date start, stop;
            DTD dtd = generateSimpleDTD(dtdsize[i]);

            
            System.out.print("\n  " + dtdsize[i] +  " | " + 
                             dtd.getDefinition(c).getStateCount() + 
                             " | ");
            boolean[][] epsilon = dtd.getDefinition(c).getEpsilonDelta();
            int max_out = 0, max_in = 0, sum = 0;
            for (int j = 0; j < epsilon.length; j++) {
                int max_out_j = 0, max_in_j = 0;
                for (int k = 0; k < epsilon.length; k++) {
                    if (epsilon[j][k]) {
                        max_out_j++; sum++;
                    }
                }
                for (int k = 0; k < epsilon.length; k++) {
                    if (epsilon[k][j]) {
                        max_in_j++;
                    }
                }
                
                if (max_out < max_out_j) {
                    max_out = max_out_j;
                }

                if (max_in < max_in_j) {
                    max_in = max_in_j;
                }
            }
            System.out.print(" " + format((1.0* sum) /dtd.getDefinition(c).getStateCount()) + " | ");
            System.out.print(" " + max_out + " | ");
            System.out.print(" " + max_in);
            
            
            
//            generateCleanSimpleFile(file, size);
//            double[] timing = new double[5];
//            //LAZY CQA
//            Arrays.fill(timing, 0.0);
//            for (int k = 0; k < timing.length; k++) {
//                ts = new StAXTokenStream(file);
//                smgr.init();
//                System.gc();
//                start = new Date();
//                cqa.compute(ts, path, dtd).size();
//                stop = new Date();
//                timing[k] = diff(start, stop);
//            }
//            System.out.print(" " + format(measure(timing)) + " | ");
//            //System.out.print(smgr);
        }
        //TestForQuery.main(args);
    }
}