/*
 * Created on Jun 10, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.util.Arrays;
import java.util.Date;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.HashCutCM;
import edu.buffalo.nsf.xmlcqa.tree.LazyCloneCM;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager4;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;

/**
 * @author staworko
 *  
 */
public class TestForErrors extends TestUtil
{

    public static void main(String[] args) throws Exception
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        double[] errors = { 
                           0.000, 0.005, 0.010, 0.015, 0.020, 0.025, 0.030, 
                           0.035, 0.040, 0.045, 0.050, 0.055, 0.060, 0.065, 
                           0.070, 0.075, 0.080, 0.085, 0.090, 0.095, 0.100,
                           0.100, 0.105, 0.110, 0.115, 0.120, 0.125, 0.130, 
                           0.135, 0.140, 0.145, 0.150, 0.155, 0.160, 0.165, 
                           0.170, 0.175, 0.180, 0.185, 0.190, 0.195, 0.200,
                           
        };
        int size = 100000;
        CollectionManager cm1 = CollectionManager.ARRAY_LIST_CM;
        CollectionManager cm2 = new LazyCloneCM(new HashCutCM(CollectionManager.ARRAY_LIST_CM));
        OperationManager  mgr1 = new OperationManager2(cm1);
        OperationManager  mgr2 = new OperationManager4(cm2);
        QueryAnswer qa = new QueryAnswer(mgr1);
        CQA cqa = new CQA(mgr2, 5);
        TokenStream ts;
        Date start, stop;
        DTD dtd = simpleDTD;
        Query path = simpleQuery;
        System.out.print("  Errors (%) |  CQA  |  STD_DEV  ");
        for (int i = 0; i < errors.length; i++) {
            System.out.print("\n       " + format(errors[i]*100) + " | ");
            double[] timing = new double[5];
            //LAZY CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                generateDirtySimpleFile(file, size, errors[i]);
                ts = new StAXTokenStream(file);
                System.gc();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(measure(timing)) + " | ");
            System.out.print(" " + format(std_dev(timing)) + " | ");
        }
    }
}