/*
 * Created on Jun 10, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.util.Arrays;
import java.util.Date;
import edu.buffalo.nsf.xmlcqa.data.query.Axis;
import edu.buffalo.nsf.xmlcqa.data.query.FilterExpr;
import edu.buffalo.nsf.xmlcqa.data.query.NodeTest;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.query.Query.Step;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.test.Test;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;
import edu.buffalo.nsf.xmlcqa.tree.StatOM;

/**
 * @author staworko
 *  
 */
public class TestForQuery extends Test
{

    public static void main(String[] args) throws Exception
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] qlength = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
                16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
                32, 33, 34, 35, 36, 37, 38, 39, 40 };
        int size = 100000;
        OperationManager mgr = new OperationManager2(CollectionManager.ARRAY_LIST_CM);
        StatOM smgr = new StatOM(mgr);
        QueryAnswer qa = new QueryAnswer(mgr);
        CQA cqa = new CQA(mgr, 4);
        System.out.print("  Query  |  QA  | CQA | CQA:QA");
        for (int i = 0; i < qlength.length; i++) {
            TokenStream ts;
            Date start, stop;
            int s;
            generateFile(file, size);
            System.out.print("\n  " + (qlength[i] + 2) + " | ");
            Step[] steps = new Step[qlength[i] + 2];
            steps[0] = new Step(Axis.LEFT, NodeTest.NODE, FilterExpr
                    .createTagFilter(a));
            steps[1] = new Step(Axis.CHILD, NodeTest.STAR, FilterExpr.EMPTY);
            for (int j = 0; j < qlength[i]; j++) {
                steps[j + 2] = new Step(Axis.CHILD_TR, NodeTest.STAR,
                                        FilterExpr.EMPTY);
            }
            Query q = new Query(steps);
            double[] timing = new double[5];
            //SEMI QA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                System.gc();
                //mgr.init();
                ts = new StAXTokenStream(file);
                start = new Date();
                qa.compute(ts, q);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            double qat = measure(timing);
            System.out.print(" " + format(qat) + " " + mgr + " | ");
            //LAZY CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                //mgr.init();
                System.gc();
                start = new Date();
                cqa.compute(ts, q, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            double cqat = measure(timing);
            System.out.print(" " + format(cqat) + " " + mgr + " | ");
            System.out.print(" " + format(cqat / qat));
        }
    }
}