/*
 * Created on Jun 13, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.util.Arrays;
import java.util.Date;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;
import edu.buffalo.nsf.xmlcqa.tree.StatOM;

/**
 * @author staworko
 *  
 */
public class TestForResultSize extends TestUtil
{

    public static void main(String[] args) throws Throwable
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        double[] result_size = { 0.0, 0.01, 0.05, 0.10, 0.15, 0.20, 0.25, 0.30,
                0.35, 0.40, 0.45, 0.50, 0.55, 0.60, 0.65, 0.70, 0.75, 0.80,
                0.85, 0.90, 0.95, 1.0 };
        int size = 100000;
        OperationManager mgr = new OperationManager2(CollectionManager.ARRAY_LIST_CM);
        StatOM smgr = new StatOM(mgr);
        QueryAnswer qa = new QueryAnswer(mgr);
        CQA cqa = new CQA(mgr, 4);
        Query path = textQuery;
        DTD dtd = textDTD.init();
        TokenStream ts;
        Date start, stop;
        int s;
        double cqat, qat;
        System.out.print("  Result size (%) | QA | CQA | CQA:QA");
        for (int i = 0; i < result_size.length; i++) {
            System.out.print("\n  " + ((int) (result_size[i] * 100)) + " | ");
            double[] timing = new double[5];
            generateCleanTextFile(file, size, ((int) (size * result_size[i])));
            //QA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                smgr.init();
                System.gc();
                start = new Date();
                qa.compute(ts, path);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(qat = measure(timing)) + " | ");
            //System.out.print(smgr);
            //LAZY CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                smgr.init();
                System.gc();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(cqat = measure(timing)) + " | ");
            System.out.print(" " + format(cqat / qat) + " | ");
            //System.out.print(smgr);
        }
    }
}