/*
 * Created on Jun 22, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.io.File;
import java.util.Arrays;
import java.util.Date;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.FreezingCM;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;
import edu.buffalo.nsf.xmlcqa.tree.StatCM;


/**
 * @author staworko
 *
 */
public class TestForSize extends TestUtil
{

    public static void main(String[] args) throws Exception
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] size = { //10000, 20000, 30000, 40000, 50000, 60000, 70000, 80000,
                //90000, 100000, 110000, 120000, 130000, 140000, 150000, 160000,
                170000, 180000, 190000, 200000 };
        StatCM stat1 = new StatCM(CollectionManager.ARRAY_LIST_CM);
        StatCM stat2 = new StatCM(new FreezingCM(CollectionManager.ARRAY_LIST_CM));
        OperationManager mgr = new OperationManager2(stat1);
        OperationManager lmgr = new OperationManager2(stat2);
        QueryAnswer qa = new QueryAnswer(mgr);
        CQA cqa = new CQA(lmgr, 10);
        CQA lcqa = new CQA(lmgr, 10);
        TokenStream ts;
        Date start, stop;
        DTD dtd = simpleDTD;
        Query path = simpleQuery;        

        System.out.print("  Nodes | Size | QA | CQA | FCQA | CQA/QA | FCQA/QA | FCQA/CQA");
        for (int i = 0; i < size.length; i++) {
            System.out.print("\n  " + size[i] + " | ");
            generateCleanSimpleFile(file, size[i]);
            double fsize = ((1.0 * new File(file).length()) / 1024.0) / 1024.0;
            System.out.print(" " + format(fsize) + " | \n");
            double[] timing = new double[1];
            double tcqa,tqa,tlcqa;
            
            
            //QA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc(); stat1.init();
                start = new Date();
                qa.compute(ts, path);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tqa = measure(timing)) + " : " + stat1 + " | \n");

            //CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc(); stat1.init();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tcqa = measure(timing)) + " : " + stat1 + " | \n");

            //LCQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc(); stat2.init();
                start = new Date();
                lcqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tlcqa = measure(timing)) +  " : " + stat2 + " | \n");

            System.out.print(" " + format(tcqa/tqa) + " | ");
            System.out.print(" " + format(tlcqa/tqa) + " | ");
            System.out.print(" " + format(tlcqa/tcqa) + " | ");
            
        }

    }
}
