/*
 * Created on Jun 14, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.io.File;
import java.util.Arrays;
import java.util.Date;
import javax.xml.stream.XMLStreamException;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;
import edu.buffalo.nsf.xmlcqa.tree.StatOM;

/**
 * @author staworko
 *  
 */
public class TestForSizeWithErrors extends TestUtil
{

    public static void main(String[] args) throws Exception, XMLStreamException
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] size = { 10000, 20000, 30000, 40000, 50000, 60000, 70000, 80000,
                90000, 100000, 110000, 120000, 130000, 140000, 150000, 160000,
                170000, 180000, 190000, 200000 };
        OperationManager mgr = new OperationManager2(CollectionManager.ARRAY_LIST_CM);
        StatOM smgr = new StatOM(mgr);
        QueryAnswer qa = new QueryAnswer(smgr);
        CQA cqa = new CQA(mgr, 4);
        TokenStream ts;
        Date start, stop;
        DTD dtd = simpleDTD;
        Query path = simpleQuery;
        System.out.print("  Nodes | Size | 0.1%  CQA | 0.01% CQA");
        //        for (int j =0; j < result.length; j++) {
        //            System.out.print(" | "+result[j]);
        //        }
        for (int i = 0; i < size.length; i++) {
            System.out.print("\n  " + size[i] + " | ");
            int errors = size[i] / 1000;
            generateDirtySimpleFile(file, size[i], errors);
            double fsize = ((1.0 * new File(file).length()) / 1024.0) / 1024.0;
            System.out.print(" " + format(fsize) + " | ");
            double[] timing = new double[1];
            //LAZY CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                smgr.init();
                System.gc();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(measure(timing)) + " | ");
            errors = size[i] / 10000;
            generateDirtySimpleFile(file, size[i], errors);
            //LAZY CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                smgr.init();
                System.gc();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(measure(timing)) + " | ");
        }
    }
}