/*
 * Created on Jun 23, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.test.cqa;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Arrays;
import java.util.Date;
import javax.xml.stream.XMLStreamException;
import edu.buffalo.nsf.xmlcqa.data.dtd.DTD;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.graph.CQA;
import edu.buffalo.nsf.xmlcqa.tree.CollectionManager;
import edu.buffalo.nsf.xmlcqa.tree.DummyCM;
import edu.buffalo.nsf.xmlcqa.tree.FreezingCM;
import edu.buffalo.nsf.xmlcqa.tree.HashCutCM;
import edu.buffalo.nsf.xmlcqa.tree.LazyCloneCM;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager2;
import edu.buffalo.nsf.xmlcqa.tree.OperationManager4;
import edu.buffalo.nsf.xmlcqa.tree.QueryAnswer;
import edu.buffalo.nsf.xmlcqa.tree.StatCM;
import edu.buffalo.nsf.xmlcqa.tree.StatOM;


/**
 * @author staworko
 *
 */
public class VariousTest extends TestUtil
{
    public static void main(String[] args) throws IOException, FileNotFoundException, XMLStreamException 
    {
        String file = "d:\\work\\xml\\test\\qa.xml";
        int[] size = { 10000,  20000,  30000,  40000,  50000,  60000,   70000,  80000,  90000, 100000, 
                       110000, 120000, 130000, 140000, 150000, 160000, 170000, 180000, 190000, 200000,
//                       210000, 220000, 230000, 240000, 250000, 260000, 270000, 280000, 290000, 300000,
        };
//        DummyCM stat1 = new DummyCM(CollectionManager.ARRAY_LIST_CM);
        StatCM stat1 = new StatCM(new DummyCM(CollectionManager.ARRAY_LIST_CM));
//        DummyCM stat2 = new DummyCM(CollectionManager.ARRAY_LIST_CM);
        StatCM stat2 = new StatCM(new DummyCM(new FreezingCM(new HashCutCM(CollectionManager.ARRAY_LIST_CM))));
//        DummyCM stat3 = new DummyCM(new LazyCloneCM(new HashCutCM(CollectionManager.ARRAY_LIST_CM)));
        StatCM stat3 = new StatCM(new DummyCM(new LazyCloneCM(new HashCutCM(CollectionManager.ARRAY_LIST_CM))));
        StatOM mgr1  = new StatOM(new OperationManager2(stat1));
        StatOM mgr2  = new StatOM(new OperationManager2(stat2));
        StatOM mgr3  = new StatOM(new OperationManager4(stat3));
        QueryAnswer qa = new QueryAnswer(mgr1);
        CQA cqa  = new CQA(mgr2, 5);
        CQA lcqa = new CQA(mgr3, 5);
        TokenStream ts;
        Date start, stop;
        DTD dtd = simpleDTD;
        Query path = simpleQuery;

        System.out.print("  Nodes | Size | QA | CQA | LCQA |  CQA/QA | LCQA/QA | LCQA/CQA\n");
        for (int i = 0; i < size.length; i++) {
            System.out.print(" " + size[i] + " | ");
            generateDirtySimpleFile(file, size[i],size[i]/100);
            double fsize = ((1.0 * new File(file).length()) / 1024.0) / 1024.0;
            System.out.print(" " + format(fsize) + " | ");
            double[] timing = new double[5];
            double tqa,tcqa,tlcqa;
            
            //QA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc(); 
                stat1.init();
                mgr1.init();
                start = new Date();
                qa.compute(ts, path);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tqa = measure(timing))+ " | ");

            //CQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc(); 
                stat2.init();
                mgr2.init();
                start = new Date();
                cqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tcqa = measure(timing)) + " | ");

            //LCQA
            Arrays.fill(timing, 0.0);
            for (int k = 0; k < timing.length; k++) {
                ts = new StAXTokenStream(file);
                System.gc();
                mgr3.init();
                stat3.init();
                start = new Date();
                lcqa.compute(ts, path, dtd);
                stop = new Date();
                timing[k] = diff(start, stop);
            }
            System.out.print(" " + format(tlcqa = measure(timing)) + " | " );
            
            System.out.print(" " + format(tcqa/tqa) + " | ");
            System.out.print(" " + format(tlcqa/tqa) + " | ");
            System.out.print(" " + format(tlcqa/tcqa) + " | ");
            System.out.print("\n");            
            
//            System.out.print("QA-CM-STAT    = " + stat1 + "\n");
//            System.out.print("CQA-CM-STAT   = " + stat2 + "\n");
//            System.out.print("LCQA-CM-STAT  = " + stat3 + "\n");
//            System.out.print("QA-MGR-STAT   = " + mgr1 + "\n");
//            System.out.print("CQA-MGR-STAT  = " + mgr2 + "\n");
//            System.out.print("LCQA-MGR-STAT = " + mgr3 + "\n");
            
            System.out.flush();
        }

    }
}
