/*
 * Created on Jun 23, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.tree;

import java.util.Collection;
import org.apache.commons.collections.Unmodifiable;
import org.apache.commons.collections.collection.UnmodifiableCollection;


/**
 * @author staworko
 *
 */
public class FreezingCM extends CMWrapper
{
    private Collection EMPTY;    
    
    public FreezingCM(CollectionManager cm)
    {
        super(cm);
        this.EMPTY = freeze(cm.empty());
    }
    
    private Collection freeze(Collection col)
    {
        return UnmodifiableCollection.decorate(col);
    }
    
    public Collection empty()
    {
        return EMPTY;
    }
    
//    
//    public Collection copy(Collection dst, Collection src)
//    {
//        if (dst instanceof Unmodifiable) {
//            return freeze(src);
//        } else {
//            return super.copy(dst,src);
//        }
//    }
    
    public Collection clone(Collection col)
    {
        return freeze(col);
    }
    
    public Collection add(Collection col1, Collection col2)
    {
        if (col2 == EMPTY) {
            return col1;
        } else if (col1 == EMPTY){
            return freeze(col2);
        } else { 
            if (col1 instanceof Unmodifiable){
                col1 = cm.clone(col1);
            }
            
            return super.add(col1,col2);
        }
    }
    
    public Collection add(Collection col, TreeNode node)
    {
        if (col instanceof Unmodifiable){
            col = cm.clone(col);
        }
        
        return super.add(col,node);
    }    
    
    public Collection cut(Collection col1, Collection col2)
    {
        if (col1 instanceof Unmodifiable) {
            col1 = cm.clone(col1);
        }
        
        return super.cut(col1,col2);
    }
}
