/*
 * Created on Jun 1, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.tree;

import java.util.Collection;
import edu.buffalo.nsf.xmlcqa.data.dtd.Tag;
import edu.buffalo.nsf.xmlcqa.data.query.Query;
import edu.buffalo.nsf.xmlcqa.data.stream.Token;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;


/**
 * @author staworko
 *
 */
public class QueryAnswer
{
    private OperationManager mgr;
    
    public QueryAnswer (OperationManager mgr)
    {
        this.mgr = mgr;
    }
    
    public Collection compute(TokenStream ts, Query q)
    {
        Token tok = ts.next();
        Tag t = tok.getTag();
        TreeNode root = new TreeNode(tok);
        NodeCollector main = mgr.createRoot(q,root);
        return compute(ts,main).getNodes(q.length-1);
    }

    protected NodeCollector compute(TokenStream ts, NodeCollector parent)
    {
        int i = 0;

        Token 		  t    = null;
        NodeCollector curr = null;
        
        while (ts.hasNext() && (t = ts.next()) != Token.CLOSING_TOKEN) {
            
            curr = mgr.createChild(parent,i++,t);
            
            if (t.isOpening()) {
                curr = compute(ts,curr);
            }
            
            parent = mgr.hook(parent,curr);
        }
        
        return parent;
    }   
}
