/*
 * Created on Jun 23, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.tree;

import java.util.Collection;


/**
 * @author staworko
 *
 */
public class StatCM extends CollectionManager
{

    
    private CollectionManager cm;
    
    private static final int EMPTY = 0;
    private static final int CLONE = 1;
    private static final int COPY  = 2;
    private static final int ADD   = 3;
    private static final int CUT   = 4;
    private long[] stat = new long[5];
    
    private long[] measure = new long[10];
    private int i = 0;
    private void start()
    {
        measure[i++] = System.currentTimeMillis();
    }
    
    private Collection stop(Collection res, int statNo)
    {
        stat[statNo] += System.currentTimeMillis() - measure[--i];
        return res;
    }

    public void init()
    {
        for (int i = 0; i < stat.length; i++) {
            stat[i] = 0;
        }
    }
    
    public StatCM(CollectionManager cm) 
    {
        this.cm = cm;
    }
    
    public Collection empty()    
    {
        start();
        return stop(cm.empty(),EMPTY);        
    }
    
    
    public Collection clone(Collection col)
    {
        start();
        return stop(cm.clone(col),CLONE);
    }
    
//    public Collection copy(Collection dst, Collection src)
//    {
//        start();
//        return stop(cm.copy(dst,src),COPY);
//    }
    
    public Collection add(Collection dst, Collection src)
    {
        start();
        return stop(cm.add(dst,src),ADD);
    }
    
    public Collection add(Collection dst, TreeNode node)
    {
        start();
        return stop(cm.add(dst,node),ADD);
    }
    
    public Collection cut(Collection dst, Collection src)
    {
        start();
        return stop(cm.cut(dst,src),CUT);
    }   
    
    
    public String toString()
    {
        return "StatCM:[" +
        	"empty = " + stat[EMPTY]/1000.0 + ", " +	
        	"clone = " + stat[CLONE]/1000.0 + ", "+
        	"copy = " + stat[COPY]/1000.0 + ", " +
        	"add = " + stat[ADD]/1000.0 + ", " +
        	"cut = " + stat[CUT]/1000.0 + ", " +
        	"total = " + (stat[EMPTY] + stat[CLONE] + stat[COPY] + stat[ADD]+ stat[CUT])/1000.0 + "]";
    }
}
