/*
 * Created on Feb 26, 2005
 *
 */
package edu.buffalo.nsf.xmlcqa.tree;

import edu.buffalo.nsf.xmlcqa.data.dtd.Tag;
import edu.buffalo.nsf.xmlcqa.data.stream.Token;

/**
 * @author staworko
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public final class TreeNode
{
    protected static int realmCounter = 1;
    protected int        realm;
    protected TreeNode   parent;
    protected Token      t;
    
    protected int        pos;
    protected int        hash;

    protected TreeNode(int realm, Token t)
    {
        this.realm = realm;
        this.hash = 123 * realm;
        this.t = t;
    }

    protected TreeNode(TreeNode parent, int pos, Token t)
    {
        if ( !t.isOpening() && !t.isText()) {
            throw new IllegalArgumentException("Only opening and text tokens allowed.");
        }
        
        this.realm = parent.realm;
        this.t = t;
        this.parent = parent;
        this.pos = pos;
        this.hash = 456 * parent.hashCode() + 789 * pos;
    }

    public TreeNode(Token t)
    {
        this(realmCounter++,t);
    }

    public TreeNode getChild(int pos, Token t)
    {
        return new TreeNode(this, pos,t);
    }

    public boolean isRoot()
    {
        return parent == null;
    }

    public TreeNode getParent()
    {
        if (isRoot()) {
            throw new IllegalArgumentException("This is a root.");
        } else {
            return parent;
        }
    }
    
    public int getPosition() 
    {
        return pos;
    }
    

    public int hashCode()
    {
        return hash;
    }
    
    public Tag getTag()
    {
        if (isNode()) {
            return t.getTag();
        } else {
            return Tag.PCDATA_TAG;
        }
    }
    
    public String getText() 
    {
        return t.getText();
    }
    
    public boolean isNode()
    {
        return t.isOpening();
    }
    
    public boolean isText()
    {
        return t.isText();
    }

//    public boolean equals(Object o)
//    {
//        return this == o;
//    }

    public String toString()
    {
        return (isRoot()) ? ("root[" + realm + "]")
                : (parent.toString() + "/" + pos);
    }
    
    public TreeNode substitute(TreeNode root) {
        if (isRoot()) {
            return root;
        } else {
            return parent.substitute(root).getChild(pos,t);
        }
    }

}