/*
 * Created on Jun 10, 2005
 *
  */
package edu.buffalo.nsf.xmlcqa.util;

import java.io.File;
import java.io.FileNotFoundException;
import javax.xml.stream.XMLStreamException;
import edu.buffalo.nsf.xmlcqa.data.stream.StAXTokenStream;
import edu.buffalo.nsf.xmlcqa.data.stream.Token;
import edu.buffalo.nsf.xmlcqa.data.stream.TokenStream;
import edu.buffalo.nsf.xmlcqa.tree.NodeCollector;


/**
 * @author staworko
 *
 */
public final class Util
{
    public static NodeCollector[] concat(NodeCollector[] a, NodeCollector[] b)
    {
        NodeCollector[] result = new NodeCollector[a.length + b.length];
        
        for (int i = 0; i < a.length; i++) {
            result[i] = a[i];
        }
        
        for (int i = 0; i < b.length; i++) {
            result[a.length + i] = b[i];
        }
        
        return result;
    }
    
    public static int measureDepth(TokenStream ts)
    {
        int depth = 0;
        int max = 0;
        
        while (ts.hasNext()) {
            Token t = ts.next();
            
            if (t.isOpening()) {
                depth++;
                if (max < depth){
                    max = depth;
                }
            } else if (t.isClosing()) {
                depth--;
            }            
        }
        
        return max;
    }
    
    public static int measureDepth(String fileName) throws FileNotFoundException, XMLStreamException
    {
        return measureDepth(new StAXTokenStream(fileName));
    }
    
    public static int measureDepth(File file) throws FileNotFoundException, XMLStreamException
    {
        return measureDepth(new StAXTokenStream(file));
    }
    
}
